-- load an http module which provides an access to http functionality
local http = require( 'http' )
if not http then
    print( 'Failed to load an http module' )
    return
end

--perform an http request, specify mandatory parameters only
params = {
    --[[specify a url to send a GET request to (it's an http echo server which 
        will reply with the same headers and GET parameters)--]]
    url = 'https://postman-echo.com/get?foo1=bar1&foo2=bar2',

    --[[specify an event handler script for http events, such like a 'http_data_received' one which occures when
        there's a reply for an http request, so, for our case, when the echo server replies, this script
        gets called with a 'params.data.data' variable set to a server reply (as a string) and a
        'params.event' variable set to an 'http_data_received' string--]]
    handler = 'HUB:http_test/scripts/http_events'
}
local status, err_or_value = pcall( http.request, params );
if not status then
    print( 'Failed to perform an http request: ', err_or_value )
else
    --[[in a case of success, we have an opend http request object which id is stored into an 'err_or_value' variable,
        this id may be used to perform more advanced operations with this http module--]]
    --print( 'http.request handler: ', err_or_value )
end
